//************************************************************
//  University of Patras
//	Department of Electrical Engineering & Computer Technology
//
//	Course: Parallel Programming in AI
//	Week 05: OpenMp
//
//  Description: Simple examples  in openMP
//  	dice04.c:    A trusted dice, using custom parallel random generator
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc dice04.c -o dice04 -O3 -fopenmp
Executing:	./dice04

Output in my laptop:

0 10002264
1 9998416
2 9996976
3 9994296
4 10000760
5 10007288

real	0m0.217s
user	0m1.380s
sys	0m0.008s

*/
//************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <math.h>

#define N	60000000

unsigned int seed = 666999666 ;  // random number seed

// **************************************************************
unsigned int randUint( void )
{
#pragma omp threadprivate(seed)
	seed = seed * 1103515245 + 12345;
return seed ;
}

// **************************************************************
int main(void)
{
unsigned int x[8][6]={0} ;

#pragma omp threadprivate(seed)

#pragma omp parallel for num_threads(8)
	for( int i = 0 ; i < N ; i++ )
		x[omp_get_thread_num()][randUint()%6]++ ;

	for( int i = 0 ; i < 6 ; i++ )
		printf( "%d %u\n", i, x[0][i]+x[1][i]+x[2][i]+x[3][i]+
			x[4][i]+x[5][i]+x[6][i]+x[7][i]) ;

	return 0 ;
}
